Package net.sf.saxon.om

## Enum EmptyAtomicSequence

- java.lang.Object
- - java.lang.Enum<EmptyAtomicSequence>
  - - net.sf.saxon.om.EmptyAtomicSequence

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<EmptyAtomicSequence>`, `java.lang.Iterable<AtomicValue>`, `AtomicSequence`, `GroundedValue`, `Sequence`

      public enum EmptyAtomicSequence
      extends java.lang.Enum<EmptyAtomicSequence>
      implements AtomicSequence

  An implementation of AtomicSequence that contains no items.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `INSTANCE` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `effectiveBooleanValue()` | Get the effective boolean value of this sequence
    `java.lang.CharSequence` | `getCanonicalLexicalRepresentation()` | Get the canonical lexical representation as defined in XML Schema.
    `static EmptyAtomicSequence` | `getInstance()` |
    `int` | `getLength()` | Get the length of the sequence
    `java.lang.Comparable<?>` | `getSchemaComparable()` | Get a Comparable value that implements the XML Schema ordering comparison semantics for this value.
    `java.lang.String` | `getStringValue()` | Get a string representation of the sequence.
    `java.lang.CharSequence` | `getStringValueCS()` | Get a string representation of the sequence.
    `AtomicValue` | `head()` | Get the first item in the sequence
    `AtomicValue` | `itemAt​(int n)` | Get the Nth item in the sequence, zero-based
    `AtomicIterator<AtomicValue>` | `iterate()` | Make an iterator over the items in the sequence
    `java.util.Iterator<AtomicValue>` | `iterator()` | Return a Java iterator over the atomic sequence.
    `EmptyAtomicSequence` | `reduce()` | Reduce the sequence to its simplest form.
    `EmptyAtomicSequence` | `subsequence​(int start, int length)` | Get a subsequence of the value
    `static EmptyAtomicSequence` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static EmptyAtomicSequence[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize, toShortString`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Enum Constant Detail

    - #### INSTANCE

          public static final EmptyAtomicSequence INSTANCE

  - ### Method Detail

    - #### values

          public static EmptyAtomicSequence[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (EmptyAtomicSequence c : EmptyAtomicSequence.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static EmptyAtomicSequence valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getInstance

          public static EmptyAtomicSequence getInstance()

    - #### head

          public AtomicValue head()

      Description copied from interface: `AtomicSequence`
      Get the first item in the sequence
      Specified by:
        `head` in interface `AtomicSequence`
      Specified by:
        `head` in interface `GroundedValue`
      Specified by:
        `head` in interface `Sequence`
      Returns:
        the first item in the sequence, or null if the sequence is empty

    - #### iterate

          public AtomicIterator<AtomicValue> iterate()

      Description copied from interface: `AtomicSequence`
      Make an iterator over the items in the sequence
      Specified by:
        `iterate` in interface `AtomicSequence`
      Specified by:
        `iterate` in interface `GroundedValue`
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        an iterator over the items in the sequence

    - #### itemAt

          public AtomicValue itemAt​(int n)

      Description copied from interface: `AtomicSequence`
      Get the Nth item in the sequence, zero-based
      Specified by:
        `itemAt` in interface `AtomicSequence`
      Specified by:
        `itemAt` in interface `GroundedValue`
      Parameters:
        `n` - the index of the required item, with 0 representing the first item in the sequence
      Returns:
        the Nth item in the sequence, or null if the index is out of range

    - #### getLength

          public int getLength()

      Description copied from interface: `AtomicSequence`
      Get the length of the sequence
      Specified by:
        `getLength` in interface `AtomicSequence`
      Specified by:
        `getLength` in interface `GroundedValue`
      Returns:
        the number of items in the sequence

    - #### getCanonicalLexicalRepresentation

          public java.lang.CharSequence getCanonicalLexicalRepresentation()

      Get the canonical lexical representation as defined in XML Schema. This is not always the same as the result of casting to a string according to the XPath rules.
      Specified by:
        `getCanonicalLexicalRepresentation` in interface `AtomicSequence`
      Returns:
        the canonical lexical representation if defined in XML Schema; otherwise, the result of casting to string according to the XPath 2.0 rules

    - #### getSchemaComparable

          public java.lang.Comparable<?> getSchemaComparable()

      Get a Comparable value that implements the XML Schema ordering comparison semantics for this value. The default implementation is written to compare sequences of atomic values. This method is overridden for AtomicValue and its subclasses.

      In the case of data types that are partially ordered, the returned Comparable extends the standard semantics of the compareTo() method by returning the value `SequenceTool.INDETERMINATE_ORDERING` when there is no defined order relationship between two given values.

      Specified by:
        `getSchemaComparable` in interface `AtomicSequence`
      Returns:
        a Comparable that follows XML Schema comparison rules

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Description copied from interface: `AtomicSequence`
      Get a string representation of the sequence. The is the space-separated concatenation of the result of casting each of the items in the sequence to xs:string
      Specified by:
        `getStringValueCS` in interface `AtomicSequence`
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Returns:
        a whitespace-separated concatenation of the string values of the items making up the sequence, as a CharSequence.

    - #### getStringValue

          public java.lang.String getStringValue()

      Description copied from interface: `AtomicSequence`
      Get a string representation of the sequence. The is the space-separated concatenation of the result of casting each of the items in the sequence to xs:string
      Specified by:
        `getStringValue` in interface `AtomicSequence`
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Returns:
        a whitespace-separated concatenation of the string values of the items making up the sequence, as a String.

    - #### subsequence

          public EmptyAtomicSequence subsequence​(int start,
                                                 int length)

      Get a subsequence of the value
      Specified by:
        `subsequence` in interface `GroundedValue`
      Parameters:
        `start` - the index of the first item to be included in the result, counting from zero. A negative value is taken as zero. If the value is beyond the end of the sequence, an empty sequence is returned
        `length` - the number of items to be included in the result. Specify Integer.MAX_VALUE to get the subsequence up to the end of the base sequence. If the value is negative, an empty sequence is returned. If the value goes off the end of the sequence, the result returns items up to the end of the sequence
      Returns:
        the required subsequence. If min is

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue()

      Description copied from interface: `GroundedValue`
      Get the effective boolean value of this sequence
      Specified by:
        `effectiveBooleanValue` in interface `GroundedValue`
      Returns:
        the effective boolean value

    - #### reduce

          public EmptyAtomicSequence reduce()

      Reduce the sequence to its simplest form. If the value is an empty sequence, the result will be EmptySequence.getInstance(). If the value is a single atomic value, the result will be an instance of AtomicValue. If the value is a single item of any other kind, the result will be an instance of SingletonItem. Otherwise, the result will typically be unchanged.
      Specified by:
        `reduce` in interface `GroundedValue`
      Returns:
        the simplified sequence

    - #### iterator

          public java.util.Iterator<AtomicValue> iterator()

      Return a Java iterator over the atomic sequence.
      Specified by:
        `iterator` in interface `java.lang.Iterable<AtomicValue>`
      Returns:
        an Iterator.